/* -*- mode: js2; js2-basic-offset: 4; c-basic-offset: 4; tab-width: 4; indent-tabs-mode: nil -*-  */
/*
 * YAWL (Yet Another Window List) Gnome-Shell Extension
 *
 * Copyright (C) 2013 Vadim Cherepanov @ dbFin <vadim@dbfin.com>
 *
 * Yet Another Window List (YAWL) Gnome-Shell extension is
 * free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License (GPL)
 * as published by the Free Software Foundation, version 3
 * of the License, or any later version.
 *
 * YAWL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY: without even implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the License (in file
 * GNUGPLv3) along with the program. A copy of the License
 * is also available at <http://www.gnu.org/licenses/>.
 *
 * extension.js
 * Main extension file.
 *
 */

const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();

const Convenience = Me.imports.convenience2;
const dbFinDebugView = Me.imports.dbfindebugview;
const dbFinYAWL = Me.imports.dbfinyawl;

const Gettext = imports.gettext.domain(Me.metadata['gettext-domain']);
const _ = Gettext.gettext;

const _D = Me.imports.dbfindebug._D;

var dbfinyawl = null;

function init() {
    _D('>Initializing YAWL extension...');
    Convenience.initTranslations();
    _D('<YAWL extension initialized.');
}

function enable() {
	if (!global._yawlDebugView) {
		global._yawlDebugView = new dbFinDebugView.dbFinDebugView();
	}
    _D('>Enabling YAWL extension...');
    dbfinyawl = new dbFinYAWL.dbFinYAWL();
    _D('<YAWL extension enabled.\n>YAWL is up and running...');
}

function disable() {
	if (global._yawlDebugView) {
		global._yawlDebugView.destroy();
		global._yawlDebugView = null;
	}
    _D('<\n>Disabling YAWL extension...');
    if (dbfinyawl) {
        dbfinyawl.destroy();
        dbfinyawl = null;
    }
    _D('<YAWL extension disabled.');
}
